#pragma warning(disable:4996)

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

BYTE* LoadBMP(char *fileName, int &width, int &height, BYTE* temp_buf)
{
    DWORD            bytesread = 0;
	BITMAPFILEHEADER fileheader;
	BITMAPINFOHEADER header;
	
	FILE* fp = fopen(fileName,"rb");
	if (fp == NULL) 
	{
		return 0;
	}
	else
	{
		fread((BYTE *)&fileheader, sizeof(BITMAPFILEHEADER), 1, fp);
		if ( fileheader.bfType != *(unsigned short int*)("BM") )
		{
			fclose(fp);
			return 0;
		}

		fread((BYTE *)&header, sizeof(BITMAPINFOHEADER), 1, fp);

		bytesread = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	    if (header.biCompression != BI_RGB)
		{
	    	fclose(fp);
	    	return 0;
	    }

		if (header.biClrUsed == 0) header.biClrUsed = 1 << header.biBitCount;

		// read colormap
		RGBQUAD *colormap = NULL;

		switch (header.biBitCount) {
		case 24:
			break;
			// read pallete 
		case 1:
		case 4:
		case 8:
			colormap = new RGBQUAD[header.biClrUsed];
			if (colormap==NULL) {
				fclose(fp);
                //Betelt a memria
				return 0;
			}

			for (DWORD i = 0 ; i < header.biClrUsed ; ++i) 
			{
				BYTE r,g,b, dummy;

				fread((BYTE *)&(b),1,1,fp);
				bytesread++;

				fread((BYTE  *)&(g),1,1,fp); 
				bytesread++;

				fread((BYTE  *)&(r),1,1,fp); 
				bytesread++;

				fread((BYTE  *)&(dummy),1,1,fp); 
				bytesread++;

				colormap[i].rgbRed   = r;
				colormap[i].rgbGreen = g;
				colormap[i].rgbBlue  = b;
			}
			break;
		}


		if (bytesread > fileheader.bfOffBits) {
			fclose(fp);
			//Hibs paletta
			delete [] colormap;
			return 0;
		}

		while (bytesread < fileheader.bfOffBits) 
		{
			char dummy;
			fread(&dummy,1,1,fp);
			bytesread++;
		}

		int w=header.biWidth;
		int h=header.biHeight;

		// globals for display
		width = w;
		height = h;

		long row_size = w * 3;

		long bufsize = (long)w * 3 * (long)h;

		// clear old image buffer
		if (temp_buf!=NULL) 
		{
			delete [] temp_buf;
			temp_buf=NULL;
		}

		// alloc our buffer
		temp_buf = new BYTE [bufsize];
		if (temp_buf==NULL) {
		  printf("Cannot allocate memory...");
		//Memria alloklsi hiba
		} else {

			long row=0;
			long rowidx=0;

			for (row=0;row<header.biHeight;++row) {

				// which row are we working on?
				rowidx=(long unsigned)(header.biHeight-1-row)*row_size;						      

				if (header.biBitCount==24) {
					
					// read a whole row
					fread((void  *)(temp_buf+rowidx),row_size,1,fp);
					bytesread+=row_size;
					
					// read DWORD padding
					while ((bytesread - fileheader.bfOffBits)&3) {
						char dummy;
						fread(&dummy,1,1,fp);
						bytesread++;
					}
				
				} else {	// 1, 4, or 8 bit image
					// pixels are packed as 1 , 4 or 8 bit vals. need to unpack them

					int bit_count = 0;
					UINT mask = (1 << header.biBitCount) - 1;

					BYTE inbyte=0;

					for (int col=0;col<w;++col) {
						
						int pix=0;

						// if we need another byte
						if (bit_count <= 0) {
							bit_count = 8;
							fread(&inbyte,1,1,fp);
							bytesread++;
						}

						// keep track of where we are in the bytes
						bit_count -= header.biBitCount;
						pix = ( inbyte >> bit_count) & mask;

						// lookup the color from the colormap - stuff it in our buffer
						*(temp_buf + rowidx + col * 3 + 0) = colormap[pix].rgbBlue;
						*(temp_buf + rowidx + col * 3 + 1) = colormap[pix].rgbGreen;
						*(temp_buf + rowidx + col * 3 + 2) = colormap[pix].rgbRed;
					}

					// read DWORD padding
					while ((bytesread - fileheader.bfOffBits)&3) {
						char dummy;
						fread(&dummy,1,1,fp);
						bytesread++;
					}
				}
			}
		
		}

		if (colormap) {
			delete [] colormap;
		}

		fclose(fp);
    }
    return temp_buf;
}
