#pragma warning(disable:4996)

#ifndef BMPSAVE_H
#define BMPSAVE_H

#include <io.h>
#include <stdlib.h>
#include <windows.h>
#define WIDTHBYTES2(bits)    ((((bits) + 31) >> 5) << 2)



BOOL VertFlipBuf(BYTE *inbuf, UINT widthBytes, UINT height)
{   
	BYTE  *tb1;
	BYTE  *tb2;

	if (inbuf==NULL)
		return FALSE;

	UINT bufsize;

	bufsize=widthBytes;

	tb1= (BYTE *)new BYTE[bufsize];
	if (tb1==NULL) {
		return FALSE;
	}

	tb2= (BYTE *)new BYTE [bufsize];
	if (tb1==NULL) {
		return FALSE;
	}
	
	UINT row_cnt;     
	ULONG off1=0;
	ULONG off2=0;

	for (row_cnt=0;row_cnt<(height+1)/2;row_cnt++) {
		off1=row_cnt*bufsize;
		off2=((height-1)-row_cnt)*bufsize;   
		
		memcpy(tb1,inbuf+off1,bufsize);
		memcpy(tb2,inbuf+off2,bufsize);	
		memcpy(inbuf+off1,tb2,bufsize);
		memcpy(inbuf+off2,tb1,bufsize);
	}	

	delete [] tb1;
	delete [] tb2;

	return TRUE;
}        


BYTE *MakeDwordAlignedBuf(BYTE *dataBuf, UINT widthPix, UINT height, UINT *uiOutWidthBytes)
{
	////////////////////////////////////////////////////////////
	// what's going on here? this certainly means trouble 
	if (dataBuf==NULL)
		return NULL;

	////////////////////////////////////////////////////////////
	// how big is the smallest DWORD-aligned buffer that we can use?
	UINT uiWidthBytes;
	uiWidthBytes = WIDTHBYTES2(widthPix * 24);

	DWORD dwNewsize=(DWORD)((DWORD)uiWidthBytes *(DWORD)height);
	BYTE *pNew;

	////////////////////////////////////////////////////////////
	// alloc and open our new buffer
	pNew=(BYTE *)new BYTE[dwNewsize];
	if (pNew==NULL) {
		return NULL;
	}
	
	////////////////////////////////////////////////////////////
	// copy row-by-row
	UINT uiInWidthBytes = widthPix * 3;
	UINT uiCount;
	for (uiCount=0;uiCount < height;uiCount++) {
		BYTE * bpInAdd;
		BYTE * bpOutAdd;
		ULONG lInOff;
		ULONG lOutOff;

		lInOff=uiInWidthBytes * uiCount;
		lOutOff=uiWidthBytes * uiCount;

		bpInAdd= dataBuf + lInOff;
		bpOutAdd= pNew + lOutOff;

		memcpy(bpOutAdd,bpInAdd,uiInWidthBytes);
	}

	*uiOutWidthBytes=uiWidthBytes;
	return pNew;
}


void SaveBMP(char *fileName, unsigned char *buffer1, int Width, int Height, BOOL VertFlip)
{
	UINT m_widthDW    = WIDTHBYTES2(Width*24);
	BYTE *tmp         = MakeDwordAlignedBuf(buffer1, Width, Height, &m_widthDW);

	if (VertFlip) VertFlipBuf(tmp, m_widthDW, Height);

	BITMAPFILEHEADER fileheader;
	fileheader.bfType      = *(unsigned short int*)("BM");
	fileheader.bfSize      = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + m_widthDW * Height;	
	fileheader.bfReserved1 = 0;
	fileheader.bfReserved2 = 0;
	fileheader.bfOffBits   = 54;

	BITMAPINFOHEADER header;
  	header.biSize          = sizeof(BITMAPINFOHEADER);
	header.biWidth         = Width;
	header.biHeight        = Height;
	header.biPlanes        = 1;
	header.biBitCount      = 24;
	header.biCompression   = BI_RGB;
	header.biSizeImage     = 0;
	header.biXPelsPerMeter = 0;
	header.biYPelsPerMeter = 0;
	header.biClrUsed       = 0;
	header.biClrImportant  = 0;

	FILE *fp = fopen(fileName,"wb");
	if (fp == NULL) return;

	fwrite((BYTE *)&fileheader, sizeof(BITMAPFILEHEADER), 1, fp);
	fwrite((BYTE *)&header    , sizeof(BITMAPINFOHEADER), 1, fp);

	long rowidx, row_size = m_widthDW;

	for ( long row = 0 ; row < header.biHeight ; ++row ) 
	{
		rowidx = (long unsigned)row * row_size;						      
		if ( fwrite( (void*)(tmp+rowidx), row_size, 1, fp ) == -1 ) break;
	}

	delete [] tmp;           
	fclose(fp);
}


#endif
