// This is the main DLL file.
#pragma warning(disable:4996) // fopen deprecated

#include <windows.h>
#include <string>
#include <stdio.h>
#include "out_shppolylines.h"
#include "polylinize.h"
#include "bmpsave.h"

using namespace System::Windows::Forms;
using namespace std;

/*
void convert_back(byte *in, byte* out, int w, int h)
{
	// visszaalakts
	byte red[]   = { 255, 0,   0, 255,   0 };
	byte green[] = { 255, 0, 255,   0,   0 };
	byte blue[]  = { 255, 0,   0,   0, 255 };
	for (int i = 0; i < w * h; i++) 
	{
		out[i * 3 + 0] = blue[in[i]];
		out[i * 3 + 1] = green[in[i]];
		out[i * 3 + 2] = red[in[i]];
	}
}
*/

// ---------------------------------------------------------------------------------------------------------------

namespace ImageSaver 
{
	bool ImageSaver::DumpErrorMessage(String^ msg, xml_node^ xn)
	{
		MessageBox::Show("SHP Polylines modul: " + msg + " fail");
		delete xn;
		return false;
	}

	String^ ImageSaver::GetExportModuleName()
	{
		return "SHP Polylines (from 1bpp image)";
	}

	int ImageSaver::GetAPIVersion()
	{
		return IMAGEFILTER_API_VERSION;
	}

	bool ImageSaver::Save_Image(String^ filename, IntPtr ptr, IntPtr size, IntPtr xml)
	{
		xml_node^ root = gcnew xml_node( xml.ToPointer() );
		xml_node^ alloc;
		int w, h, s, packed, interleaved, channelcount, pixelsize;
		int *img_ptr  = (int*)ptr.ToPointer();
		int *img_size = (int*)size.ToPointer();
		Byte* data;

		if (FilterSpace::ImageFilterBase::GetOneImageSetting(root, w, h, s, packed, interleaved, channelcount, pixelsize, data))
			return DumpErrorMessage("GetOneImageSetting", root);

		if (channelcount != 1) return DumpErrorMessage("A kp 1 csatorns kell legyen!", root);
		if (! root->XmlGetChildByName(alloc, "ChannelsBitAllocation")) return DumpErrorMessage("A kp csatornalersa nem tallhat!", root);
		if (pixelsize != 1) return DumpErrorMessage("A kp csatornja 1 bites kell legyen!", root);
		delete root;

		// --------------------------------------------
		// Framework guarantees, that stride is a dword aligned size

		int pptr = 0, psize = 0, killsignal = 0;
		filtersettings filset;
		filset.width				= w;
		filset.height				= h;
		filset.stridein				= filset.strideout = s;
		filset.datain				= data;
		filset.dataout				= new byte[h * s];
		filset.channelcountin		= filset.channelcountout = 1;
		filset.pixelsizein			= filset.pixelsizeout = 1;
		filset.mask					= 0;
		filset.nCoreEnabled			= 1;
		filset.nCoreKillSignal		= &killsignal;
		filset.processing_ptr		= &pptr;
		filset.processing_size		= &psize;
		filset.filtering_iterations_limit = 10;

		ExecuteThinningRegular(&filset);

		filset.datain = convert_bitplane_to_byteplane(filset.dataout, w, h, s, w);
		delete [] filset.dataout;
		filset.stridein		= filset.strideout		= w;
		filset.pixelsizein	= filset.pixelsizeout	= 8;
		pptr = psize = killsignal = 0;

		//                         deg        0L    0R    90L   90R   180L  180R  270L  270R
		byte morph_rw[8]                  = { 0x07, 0x12, 0x94, 0x50, 0xe0, 0x48, 0x29, 0x0a };
		byte morph_mask_rw[8]             = { 0x18, 0x85, 0x42, 0xa4, 0x18, 0xa1, 0x42, 0x25 };
		memcpy(filset.morph,      morph_rw,      8);
		memcpy(filset.morph_mask, morph_mask_rw, 8);
		filset.morph_foreground = 1;
		filset.morph_background = 0; 
		filset.filtering_iterations_limit = 1;

		ExecuteThinningMorph(&filset);

		filset.morph_phase = 1;
		filset.morph_foreground = 1;
		filset.dataout = new byte[w * h];

		ExecutePOIProcessing(&filset);

		delete [] filset.datain;
		filset.datain = filset.dataout;
		byte fork_rw[8]      = { 0x58, 0x4a, 0x1a, 0x52, 0x48, 0x0a, 0x12, 0x50 };
		byte fork_mask_rw[8] = { 0xa7, 0xb5, 0xe5, 0xad, 0xb7, 0xf5, 0xed, 0xaf };
		memcpy(filset.morph,      fork_rw,      8);
		memcpy(filset.morph_mask, fork_mask_rw, 8);
		filset.morph_foreground = 3;
		filset.morph_background = 4; 

		ExecuteThinningMorph(&filset);

		filset.morph_phase = 2;
		filset.morph_foreground = 1;
		filset.dataout = new byte[w * h];

		ExecutePOIProcessing(&filset);

		delete [] filset.datain;
		char *fname = StringToCharstring(filename);

		extract_line_segments(filset.dataout, w, h, fname);

		delete [] fname;
		delete [] filset.dataout;

		return true;
	}
}

