#ifndef SHP_POLYLINE_EXPORT_H__
#define SHP_POLYLINE_EXPORT_H__

#include <stdio.h>
#include <list>
#include "..\..\common\fast_bit_operation_macros.h"

class shp_polyline_exporter {
public:
	shp_polyline_exporter(const char *filename, int width, int height);
	~shp_polyline_exporter();
	void write_polyline(std::list<coord> c);

private:
	int w, h, rec_num, fieldlen;
	FILE *fp, *fx, *fd; // shp, shx, dbf file
};



#pragma pack(push,1)
struct shp_file_header {
	shp_file_header(int file_length, int width, int height)
	{
		// Big
		FileCode	= LE_TO_BE_INT(9994);
		Reserved[0]	= Reserved[1] = Reserved[2] = Reserved[3] = Reserved[4] = 0;
		FileLength  = LE_TO_BE_INT(file_length / 2);
		// Little
		Version		= 1000;
		ShapeType   = 3;
		Xmin = Ymin	= 0.0;
		Xmax		= (width) ? width : 1;
		Ymax		= (height) ? height : 1;
		Zmin = Zmax = Mmin = Mmax = 0.0;
	}
	// Big
	int		FileCode, Reserved[5], FileLength;	
	// Little
	int		Version, ShapeType; 
	double	Xmin, Ymin, Xmax, Ymax, Zmin, Zmax, Mmin, Mmax;
};
#pragma pack(pop)

#endif

