#include "thinning_morph.h"
#include <string.h>

#pragma warning (disable:4800)

using namespace FilterSpace;


bool ThinningMorph(filtersettings* f, int sx, int sy, int sw, int sh, Semaphore^ updater)
{
	// phase = 0 -val kell kezdeni
	byte  nbhood, val;
	int   w          = f->width;
	int   h          = f->height;
	int   s          = f->stridein;
	int   cnt        = 0;
	byte* img        = f->datain;
	byte* p          = f->dataout;
	byte  m          = f->morph[f->morph_phase];
	byte  mm		 = f->morph_mask[f->morph_phase];
	int   foreground = f->morph_foreground;
	int   background = f->morph_background;

	sx = INTERVAL_LIMITER(sx, 0, f->width - 1);
	sy = INTERVAL_LIMITER(sy, 0, f->height - 1);
	if (sw < 1) sw = f->width - sx;
	if (sh < 1) sh = f->height - sy;
	sw = INTERVAL_LIMITER(sw, 1, f->width - sx);
	sh = INTERVAL_LIMITER(sh, 1, f->height - sy);
	int dx = sx + sw;
	int dy = sy + sh;

	int processed_pixels = 0;

	for (int y = sy; y < dy; y++)
	{
		p   = f->dataout + (y - sy) * f->strideout;
		img = f->datain  +  y       * f->stridein;

		for (int x = sx; x < dx; x++)
		{
			if ((val = img[x]) == foreground)
			{
				GET_NEIGHBOURS_BYTEPLANE(f->datain, w, h, x, y, s, foreground, nbhood);
				if ((((~nbhood ^ m) | mm) & 0xff) == 0xff) // FELISMERTK A MINTT
				{
					val = background;
					cnt++;
				}
			}
			*p++ = val;
		}

		// FOR PERFORMANCE MEASUREMENT
		processed_pixels += sw;
		ImageFilterBase::UpdateFilterStatus(f, processed_pixels, updater);
		if (f->nCoreKillSignal) { if (*(f->nCoreKillSignal)) break; }
	}
	f->eliminated_pixels[f->nCoreThreadId] = cnt;

	return true;
}



bool ExecuteThinningMorph(filtersettings* filset)
{ 
	bool b = false;
	if (filset)
	{
		byte *tmp;
		filter_core_func f         = (::ThinningMorph);
		int  iteration             = 0;
		int  eliminated_pixels     = 1;
		int  cpucores              = System::Environment::ProcessorCount;
		*(filset->processing_size) = filset->width * filset->height;
		filset->nCoreThreadId      = 0;
		filset->nCoreExecutionSize = 2; 
		filset->eliminated_pixels  = new int[cpucores];
		memset(filset->eliminated_pixels, 0, sizeof(int) * cpucores); 

		// A FILTER 1X MINDENKPPEN LEFUT. HA BEFEJEZI A FUTST, AKKOR AZ ELIMINLT PIXELEK SZMT 0-RA LLTJA

		filset->dataout = new byte[filset->width * filset->height];
		memcpy(filset->dataout, filset->datain, filset->stridein * filset->height);

		while (eliminated_pixels && ((filset->filtering_iterations_limit == 0) || (iteration < filset->filtering_iterations_limit)))
		{
			*(filset->processing_ptr) = 0;

			eliminated_pixels = 0; // VOLT MIT CSINLNI?
			for (int rotation = 0; rotation < 8; rotation++)
			{
				filset->morph_phase = rotation;
				b = ImageFilterBase::ExecuteFilterBox(filset, f);
				for (int i = 0; i < cpucores; i++) eliminated_pixels += filset->eliminated_pixels[i];

				tmp				= filset->datain;
				filset->datain	= filset->dataout;
				filset->dataout = tmp;
			}
			iteration++;
		}

		delete [] filset->dataout;
		delete [] filset->eliminated_pixels;
		filset->dataout = 0;
		*(filset->processing_ptr) = *(filset->processing_size);
		*(filset->nCoreKillSignal) = 0; // RESET SIGNAL BIT IN THE MAIN PROGRAM
	}
	return b;
}


